Subject: Re: [PATCH RESEND] net: ath9k: fix use-after-free in ath9k_hif_usb_rx_cb

From: Kalle Valo <[email-masked]>
Date: Sat, 02 Oct 2021 16:11:18 +0300

Pavel Skripkin <[email-masked]> writes:

> On 9/22/21 19:42, Pavel Skripkin wrote:
>> Syzbot reported use-after-free Read in ath9k_hif_usb_rx_cb(). The
>> problem was in incorrect htc_handle->drv_priv initialization.
>>
>> Probable call trace which can trigger use-after-free:
>>
>> ath9k_htc_probe_device()
>>    /* htc_handle->drv_priv = priv; */
>>    ath9k_htc_wait_for_target()      <--- Failed
>>    ieee80211_free_hw()		   <--- priv pointer is freed
>>
>> <IRQ>
>> ...
>> ath9k_hif_usb_rx_cb()
>>    ath9k_hif_usb_rx_stream()
>>     RX_STAT_INC()		<--- htc_handle->drv_priv access
>>
>> In order to not add fancy protection for drv_priv we can move
>> htc_handle->drv_priv initialization at the end of the
>> ath9k_htc_probe_device() and add helper macro to make
>> all *_STAT_* macros NULL save.
>>
>> Fixes: fb9987d0f748 ("ath9k_htc: Support for AR9271 chipset.")
>> Reported-and-tested-by: [email-masked]
>> Reported-and-tested-by: [email-masked]
>> Signed-off-by: Pavel Skripkin <[email-masked]>
>> ---
>>
>> Why resend?
>> 	No activity on this patch since 8/6/21, Kalle Valo has asked around,
>> 	for review and no one claimed it.
>>
>> Resend changes:
>> 	1. Rebased on top of v5.15-rc2
>> 	2. Removed clean ups for macros
>> 	3. Added 1 more syzbot tag, since this patch has passed 2 syzbot
>> 	tests
>>
>
> Hi, ath9k maintainers!
>
> Does this patch need any further work? I can't see any comments on it
> since 8/6/21 and I can't see it on wireless patchwork.
>
> If this bug is already fixed and I've overlooked a fix commit, please,
> let me know. As I see syzbot hits this bug really often [1]

See my other mail I just sent about ath9k syzbot patches:

https://lore.kernel.org/linux-wireless/[email-masked]/

In summary: please wait patiently once I'm able to test the syzbot
patches on a real device.

-- 
https://patchwork.kernel.org/project/linux-wireless/list/

https://wireless.wiki.kernel.org/en/developers/documentation/submittingpatches